env:
  # if not set, it supposedly check's if a alacritty entry exists and uses xterm-256color otherwise
  # TERM: alacritty
  TERM: xterm-256color

window:
  #dimensions:
  #  columns: 0
  #  lines: 0
  #position:
  #  x: 0
  #  y: 0

  padding:
    x: 20
    y: 20

   #Spread additional padding evenly around the terminal content.
  dynamic_padding: true

  #title: Alacritty
  #class:
    #instance: Alacritty
    #general: Alacritty

  gtk_theme_variant: None

scrolling:
  history: 10000
  multiplier: 3

#selection:
  #semantic_escape_chars: ",│`|:\"' ()[]{}<>\t"
  # When set to `true`, selected text will be copied to the primary clipboard.
  #save_to_clipboard: false

# Allow terminal applications to change Alacritty's window title.
dynamic_title: true

cursor:
  style: Block # ▇ Block, _ Underline, | Beam
  unfocused_hollow: true
  # Live config reload (changes require restart)
live_config_reload: true
shell:
  program: /bin/fish
  #args:
    #- --login

mouse:
  double_click: { threshold: 300 }
  triple_click: { threshold: 300 }

  hide_when_typing: true

  url:
    launcher:
      program: xdg-open
    #  args: []
    # These are the modifiers that need to be held down for opening URLs when clicking
    # on them. The available modifiers are documented in the key binding section.
    #modifiers: None


# Mouse bindings --------------------------------------------- {{{ 
# - `mouse`:
#
#   - Middle
#   - Left
#   - Right
#   - Numeric identifier such as `5`
#
# - `action` (see key bindings)
#
# And optionally:
#
# - `mods` (see key bindings)
#mouse_bindings:
#  - { mouse: Middle, action: PasteSelection }

# }}}

# Key bindings -------------------------------------------- {{{
#
# Key bindings are specified as a list of objects. For example, this is the
# default paste binding:
#
# `- { key: V, mods: Control|Shift, action: Paste }`
#
# Each key binding will specify a:
#
# - `key`: Identifier of the key pressed
#
#    - A-Z
#    - F1-F24
#    - Key0-Key9
#
#    A full list with available key codes can be found here:
#    https://docs.rs/glutin/*/glutin/event/enum.VirtualKeyCode.html#variants
#
#    Instead of using the name of the keys, the `key` field also supports using
#    the scancode of the desired key. Scancodes have to be specified as a
#    decimal number. This command will allow you to display the hex scancodes
#    for certain keys:
#
#       `showkey --scancodes`.
#
# Then exactly one of:
#
# - `chars`: Send a byte sequence to the running application
#
#    The `chars` field writes the specified string to the terminal. This makes
#    it possible to pass escape sequences. To find escape codes for bindings
#    like `PageUp` (`"\x1b[5~"`), you can run the command `showkey -a` outside
#    of tmux. Note that applications use terminfo to map escape sequences back
#    to keys. It is therefore required to update the terminfo when changing an
#    escape sequence.
#
# - `action`: Execute a predefined action
#
#   - Copy
#   - Paste
#   - PasteSelection
#   - IncreaseFontSize
#   - DecreaseFontSize
#   - ResetFontSize
#   - ScrollPageUp
#   - ScrollPageDown
#   - ScrollLineUp
#   - ScrollLineDown
#   - ScrollToTop
#   - ScrollToBottom
#   - ClearHistory
#   - Hide
#   - Minimize
#   - Quit
#   - ToggleFullscreen
#   - SpawnNewInstance
#   - ClearLogNotice
#   - ReceiveChar
#   - None
#
#   (macOS only):
#   - ToggleSimpleFullscreen: Enters fullscreen without occupying another space
#
# - `command`: Fork and execute a specified command plus arguments
#
#    The `command` field must be a map containing a `program` string and an
#    `args` array of command line parameter strings. For example:
#       `{ program: "alacritty", args: ["-e", "vttest"] }`
#
# And optionally:
# - `mods`: Key modifiers to filter binding actions
#    - Command
#    - Control
#    - Option
#    - Super
#    - Shift
#    - Alt
#
#    Multiple `mods` can be combined using `|` like this:
#       `mods: Control|Shift`.
#    Whitespace and capitalization are relevant and must match the example.
#
# - `mode`: Indicate a binding for only specific terminal reported modes
#
#    This is mainly used to send applications the correct escape sequences
#    when in different modes.
#
#    - AppCursor
#    - AppKeypad
#    - Alt
#
#    A `~` operator can be used before a mode to apply the binding whenever
#    the mode is *not* active, e.g. `~Alt`.
#
# Bindings are always filled by default, but will be replaced when a new
# binding with the same triggers is defined. To unset a default binding, it can
# be mapped to the `ReceiveChar` action. Alternatively, you can use `None` for
# a no-op if you do not wish to receive input characters for that binding.
#
# If the same trigger is assigned to multiple actions, all of them are executed
# at once.
#key_bindings:
  # (Windows, Linux, and BSD only)
  #- { key: V,        mods: Control|Shift, action: Paste            }
  #- { key: C,        mods: Control|Shift, action: Copy             }
  #- { key: Insert,   mods: Shift,         action: PasteSelection   }
  #- { key: Key0,     mods: Control,       action: ResetFontSize    }
  #- { key: Equals,   mods: Control,       action: IncreaseFontSize }
  #- { key: Add,      mods: Control,       action: IncreaseFontSize }
  #- { key: Subtract, mods: Control,       action: DecreaseFontSize }
  #- { key: Minus,    mods: Control,       action: DecreaseFontSize }

  # (Windows only)
  #- { key: Return,   mods: Alt,           action: ToggleFullscreen }

  #- { key: Paste,                    action: Paste                            }
  #- { key: Copy,                     action: Copy                             }
  #- { key: L,         mods: Control, action: ClearLogNotice                   }
  #- { key: L,         mods: Control, chars: "\x0c"                            }
  #- { key: PageUp,    mods: Shift,   action: ScrollPageUp,   mode: ~Alt       }
  #- { key: PageDown,  mods: Shift,   action: ScrollPageDown, mode: ~Alt       }
  #- { key: Home,      mods: Shift,   action: ScrollToTop,    mode: ~Alt       }
  #- { key: End,       mods: Shift,   action: ScrollToBottom, mode: ~Alt       }

      # }}}

#debug:
  # Display the time it takes to redraw each frame.
  #render_timer: false

  # Keep the log file after quitting Alacritty.
  #persistent_logging: false

  # Log level
  #
  # Values for `log_level`:
  #   - None
  #   - Error
  #   - Warn
  #   - Info
  #   - Debug
  #   - Trace
  #log_level: Warn

  # Print all received window events.
  #print_events: false

# schemes --------------------------------------------------------- {{{

schemes:
  blueish: &blueish
    colors:
    # Default colors
    primary:
      background: '0x3f5163'
      foreground: '0xe2efe6'

    # Normal colors
    normal:
      black:   '0x111111'
      red:     '0xa54242'
      green:   '0xa9b254'
      yellow:  '0xde935f'
      blue:    '0x1bcdee'
      magenta: '0xbd88ce'
      cyan:    '0x5bc5b7'
      white:   '0xbceff7'

    # Bright colors
    bright:
      black:   '0xc5d2e6'
      red:     '0xff8484'
      green:   '0xebf39c'
      yellow:  '0xf4c76e'
      blue:    '0x97cfff'
      magenta: '0xc3a2cd'
      cyan:    '0xa5f9ee'
      white:   '0xe7fcff'



  dracula: &dracula
    primary:
      background: '#282a36'
      foreground: '#f8f8f2'
    normal:
      black:   '#000000'
      red:     '#ff5555'
      green:   '#50fa7b'
      yellow:  '#f1fa8c'
      blue:    '#caa9fa'
      magenta: '#ff79c6'
      cyan:    '#8be9fd'
      white:   '#bfbfbf'
    bright:
      black:   '#575b70'
      red:     '#ff6e67'
      green:   '#5af78e'
      yellow:  '#f4f99d'
      blue:    '#caa9fa'
      magenta: '#ff92d0'
      cyan:    '#9aedfe'
      white:   '#e6e6e6'
  gruvbox: &gruvbox
    primary:
      #background: '#1d2021' # hard contrast: background = '#1d2021'
      background: '#282828' # hard contrast: background = '#1d2021'
      foreground: '#ebdbb2' # soft contrast: background = '#32302f'
    normal:
      black:   '#282828'
      red:     '#cc241d'
      green:   '#98971a'
      yellow:  '#d79921'
      blue:    '#458588'
      magenta: '#b16286'
      cyan:    '#689d6a'
      white:   '#a89984'
    bright:
      black:   '#928374'
      red:     '#fb4934'
      green:   '#b8bb26'
      yellow:  '#fabd2f'
      blue:    '#83a598'
      magenta: '#d3869b'
      cyan:    '#8ec07c'
      white:   '#ebdbb2'

  onedark: &onedark
    primary:
      background: '#282c34'
      foreground: '#abb2bf'
    normal:
      black:   '#282c34' # NOTE: Use '#131613' for the `black` color if you'd like to see black text on the background.
      red:     '#e06c75'
      green:   '#98c379'
      yellow:  '#d19a66'
      blue:    '#61afef'
      magenta: '#c678dd'
      cyan:    '#56b6c2'
      white:   '#abb2bf'
    bright:
      black:   '#5c6370'
      red:     '#e06c75'
      green:   '#98c379'
      yellow:  '#d19a66'
      blue:    '#61afef'
      magenta: '#c678dd'
      cyan:    '#56b6c2'
      white:   '#ffffff'

# }}}

# https://github.com/alacritty/alacritty/wiki/Color-schemes
colors: *gruvbox
#background_opacity: 0.95
background_opacity: 1.0

font:
  #size: 10
  size: 12
  normal:
    #family: JetBrainsMono Nerd Font
    #family: Iosevka Term
    #family: cozette
    family: Terminus (TTF)
    #family: cherry
    #family: lucy tewi2a
    #family: Scientifica
  offset:
    x: 0
    y: 0
